import { flags } from '@salesforce/command';
import { AnyJson } from '@salesforce/ts-types';
import { TemplateCommand } from '../../../utils';
export default class Project extends TemplateCommand {
    static description: string;
    static examples: string[];
    static help: string;
    static longDescription: string;
    protected static flagsConfig: {
        projectname: flags.Discriminated<flags.Option<string>>;
        template: flags.Discriminated<flags.Option<string>>;
        outputdir: flags.Discriminated<flags.Option<string>>;
        namespace: flags.Discriminated<flags.Option<string>>;
        defaultpackagedir: flags.Discriminated<flags.Option<string>>;
        manifest: flags.Discriminated<flags.Boolean<boolean>>;
        loginurl: flags.Discriminated<flags.Option<string>>;
    };
    run(): Promise<AnyJson>;
}
