"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Copyright (c) 2019, salesforce.com, inc.
 * All rights reserved.
 * Licensed under the BSD 3-Clause license.
 * For full license text, see LICENSE.txt file in the repo root or https://opensource.org/licenses/BSD-3-Clause
 */
const path = require("path");
// tslint:disable-next-line:no-var-requires
const generator = require('yeoman-generator');
class ApexTriggerGenerator extends generator {
    constructor(args, options) {
        super(args, options);
        this.sourceRoot(path.join(__dirname, '..', 'templates', 'apextrigger'));
        this.conflicter.force = false;
    }
    writing() {
        const { template, outputdir, triggername, apiversion, triggerevents, sobject } = this.options;
        this.fs.copyTpl(this.templatePath(`${template}.trigger`), this.destinationPath(path.join(outputdir, `${triggername}.trigger`)), { triggername, sobject, triggerEvents: triggerevents }),
            this.fs.copyTpl(this.templatePath('_trigger.trigger-meta.xml'), this.destinationPath(path.join(outputdir, `${triggername}.trigger-meta.xml`)), { apiVersion: apiversion });
    }
}
exports.default = ApexTriggerGenerator;
//# sourceMappingURL=apexTriggerGenerator.js.map